//----------------------------------------------------------------------//
// NyanFi																//
//  c[o[̐ݒ													//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "CmdListDlg.h"
#include "BtnDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TToolBtnDlg *ToolBtnDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TToolBtnDlg::TToolBtnDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::FormCreate(TObject *Sender)
{
	set_ComboBox_AutoComp(this);

	//hbv^[Qbgݒ
	usr_SH->AddTargetList(Handle, BtnCmdsComboBox);
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	std::unique_ptr<TStringList> cmd_lst(new TStringList());
	cmd_lst->Text = (ScrMode==SCMD_FLIST)?
						_T("ExeMenuFile\r\nFileEdit\r\nLoadWorkList\r\nOpenByApp\r\nOpenByWin\r\nTextViewer\r\n") : null_TCHAR;
	//GCAX
	for (int i=0; i<ExtMenuList->Count; i++) {
		UnicodeString itm = get_csv_item(ExtMenuList->Strings[i], 3);
	 	if (!itm.IsEmpty()) cmd_lst->Add("$" + itm);
	}
	for (int i=0; i<ExtToolList->Count; i++) {
		UnicodeString itm = get_csv_item(ExtToolList->Strings[i], 4);
	 	if (!itm.IsEmpty()) cmd_lst->Add("$" + itm);
	}

	BtnCmdsComboBox->Items->Assign(cmd_lst.get());
	BtnCmdsComboBox->Text = EmptyStr;

	ButtonList = GetCurBtnList();

	BtnListBox->Tag = LBTAG_HAS_SICO;
	set_ListBoxItemHi(BtnListBox);
	UserModule->InitializeListBox(BtnListBox);

	BtnListBox->Items->Assign(ButtonList);
	CmdLabel->Caption = "sR}h (ExeCommands ̃p[^)";
	CaptionEdit->Text = EmptyStr;
	IconEdit->Text	  = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	UserModule->UninitializeListBox();

	IniFile->SavePosInfo(this);
}

//---------------------------------------------------------------------------
//bv󂯓
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::WmDropped(TMessage &msg)
{
	UnicodeString fnam = DroppedList->Strings[0];
	BtnCmdsComboBox->Text = UnicodeString().sprintf(_T("OpenByWin_\"%s\""), fnam);
	IconEdit->Text		  = get_IconName(fnam);
}

//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::FormResize(TObject *Sender)
{
	BtnListBox->Invalidate();
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::OkButtonClick(TObject *Sender)
{
	if (ButtonList) ButtonList->Assign(BtnListBox->Items);
}

//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::BtnCmdsComboBoxChange(TObject *Sender)
{
	UnicodeString anam = BtnCmdsComboBox->Text;
	if (remove_top_Dollar(anam)) {
		//ACR擾
		UnicodeString inam;
		//Oc[
		TStringDynArray itm_buf = record_of_csv_list(ExtToolList, anam, 4, EXTTOOL_CSVITMCNT);
		if (itm_buf.Length==EXTTOOL_CSVITMCNT)
			inam = itm_buf[1];
		//ǉj[
		else {
			itm_buf = record_of_csv_list(ExtMenuList, anam, 3, EXTMENU_CSVITMCNT);
			if (itm_buf.Length==EXTMENU_CSVITMCNT) inam = itm_buf[5];
		}

		if (!inam.IsEmpty()) IconEdit->Text = inam;
	}
}

//---------------------------------------------------------------------------
//t@CQ
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::RefCmdsBtnClick(TObject *Sender)
{
	UnicodeString cmd = get_CmdStr(BtnCmdsComboBox->Text);
	if (contained_wd_i(_T("ExeMenuFile|FileEdit|LoadWorkList|OpenByApp|OpenByWin|TextViewer"), cmd)) {
		UserModule->PrepareOpenDlg(_T("R}hp[^̎w"), _T("*.*"), NULL, RefParamPath);

		UnicodeString fnam;
		if (UserModule->OpenDlgToStr(fnam)) {
			RefParamPath = ExtractFilePath(fnam);
			if (USAME_TI(cmd, "OpenByWin"))
				IconEdit->Text = get_IconName(fnam);
			else if (contained_wd_i(_T("ExeMenuFile|LoadWorkList"), cmd))
				fnam = to_relative_name(fnam);

			BtnCmdsComboBox->Text = UnicodeString().sprintf(_T("%s_\"%s\""), cmd, fnam);
		}
	}
	else if (CmdFileListDlg->ShowToSelect()==mrOk)
		BtnCmdsComboBox->Text = "@" + to_relative_name(CmdFileListDlg->CmdFileName);
}
//---------------------------------------------------------------------------
//ACRQ
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::RefIconBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("ACR̎w"), F_FILTER_ICO, NULL, IconFilePath);
	if (UserModule->OpenDlgToEdit(IconEdit, true)) IconFilePath = ExtractFilePath(rel_to_absdir(IconEdit->Text));
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::IconEditChange(TObject *Sender)
{
	usr_SH->draw_SmallIcon(rel_to_absdir(IconEdit->Text), IcoImage, scl_BtnFace);
}

//---------------------------------------------------------------------------
//t@CҏW
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::EditFileActionExecute(TObject *Sender)
{
	open_by_TextEditor(get_cmds_prm_file(BtnCmdsComboBox->Text));
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::EditFileActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !get_cmds_prm_file(BtnCmdsComboBox->Text).IsEmpty();
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::BtnListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
		TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv  = lp->Canvas;
	cv->Font->Assign(lp->Font);
	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);

	int x = Rect.Left + 4;
	int y = Rect.Top + get_TopMargin(cv);

	TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[Index], 3, true);
	//Zp[^
	if (is_separator(itm_buf[0])) {
		draw_Separator(cv, Rect);
		int w = extract_int_def(itm_buf[1], -1);
		if (w>=0) cv->TextOut(BtnCmdsComboBox->Left, y, UnicodeString().sprintf(_T("< %u >"), w));
	}
	//{^
	else {
		x += 4;
		if (usr_SH->draw_SmallIcon(rel_to_absdir(itm_buf[2]), cv, x, y)) x += ScaledInt(18);
		cv->TextOut(x, y, itm_buf[0]);
		x = BtnCmdsComboBox->Left;
		cv->TextOut(x, y, itm_buf[1]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::BtnListBoxClick(TObject *Sender)
{
	TListBox *lp = (TListBox*)Sender;
	if (lp->Count==0) return;

	if (lp->ItemIndex==-1) lp->ItemIndex = 0;
	int idx = lp->ItemIndex;

	TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[idx], 3, true);
	CaptionEdit->Text	  = itm_buf[0];
	BtnCmdsComboBox->Text = itm_buf[1];
	IconEdit->Text		  = itm_buf[2];

	CmdLabel->Caption = is_separator(itm_buf[0])? "Zp[^̕ (ȗ4)" : "sR}h (ExeCommands ̃p[^)";
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::BtnListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (UserModule->ListBoxOpeItem(get_KeyStr(Key, Shift))) Key = 0;
}

//---------------------------------------------------------------------------
//CSVڂ쐬
//---------------------------------------------------------------------------
UnicodeString __fastcall TToolBtnDlg::MakeCsvItem()
{
	return UnicodeString().sprintf(_T("%s,%s,%s"),
			make_csv_str(CaptionEdit->Text), make_csv_str(BtnCmdsComboBox->Text), make_csv_str(IconEdit->Text));
}

//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::AddBtnActionExecute(TObject *Sender)
{
	BtnListBox->ItemIndex = BtnListBox->Items->Add(MakeCsvItem());
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::AddBtnActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled
		= ((!CaptionEdit->Text.IsEmpty() || !IconEdit->Text.IsEmpty()) && BtnListBox->Count<MAX_TOOLBTN);
}

//---------------------------------------------------------------------------
//}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::InsBtnActionExecute(TObject *Sender)
{
	BtnListBox->Items->Insert(BtnListBox->ItemIndex, MakeCsvItem());
	BtnListBox->ItemIndex = BtnListBox->ItemIndex - 1;
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::InsBtnActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled
		= ((!CaptionEdit->Text.IsEmpty() || !IconEdit->Text.IsEmpty()) &&
			BtnListBox->Count<MAX_TOOLBTN && BtnListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::ChgBtnActionExecute(TObject *Sender)
{
	int idx = BtnListBox->ItemIndex;  if (idx==-1) return;
	BtnListBox->Items->Strings[idx] = MakeCsvItem();
}
//---------------------------------------------------------------------------
void __fastcall TToolBtnDlg::ChgBtnActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (!CaptionEdit->Text.IsEmpty() || !IconEdit->Text.IsEmpty());
}
//---------------------------------------------------------------------------

