//----------------------------------------------------------------------//
// MP3 ID3^Ȍ												//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include "usr_str.h"
#include "usr_wic.h"
#include "usr_file_ex.h"
#include "usr_shell.h"
#include "usr_id3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
unsigned int get_SynchsafeInt(BYTE *p)
{
	return (unsigned int)(((p[0]&0x7f) << 21) + ((p[1]&0x7f) << 14) + ((p[2]&0x7f) << 7) + (p[3] & 0x7f));
}
//---------------------------------------------------------------------------
unsigned int get_32bitInt(BYTE *p)
{
	return (unsigned int)((p[0] << 24) + (p[1] << 16) + (p[2] << 8) + p[3]);
}
//---------------------------------------------------------------------------
unsigned int get_24bitInt(BYTE *p)
{
	return (unsigned int)((p[0] << 16) + (p[1] << 8) + p[2]);
}

//---------------------------------------------------------------------------
UnicodeString get_str_from_buf(char *c, int size)
{
	std::unique_ptr<char[]> ts(new char[size + 1]);
	char *p = ts.get();
	::CopyMemory(p, c, size);
	p += size;
	*p = '\0';
	return UnicodeString(ts.get());
}

//---------------------------------------------------------------------------
//o[W擾A擪t[wb_
//  ߂l: 1=v1?  3=v2.3  4=v2.4
//---------------------------------------------------------------------------
bool ID3_getVer_toFrame(TFileStream *fs, unsigned int *last, unsigned int *majv)
{
	try {
		id3_hdr idhdr;
		if (fs->Read(&idhdr, 10)<10) Abort();
		if (idhdr.hdr_id[0]!='I' || idhdr.hdr_id[1]!='D' || idhdr.hdr_id[2]!='3') Abort();
		unsigned int size = get_SynchsafeInt(&idhdr.size[0]);
		*last = size + 10;
		*majv = idhdr.maj_ver;
		if (idhdr.maj_ver!=2 && idhdr.maj_ver!=3 && idhdr.maj_ver!=4) Abort();
		if (idhdr.maj_ver>=3 && (idhdr.flag & 0x40)) {
			//gwb_Γǂݔ΂
			BYTE exsz[4];
			id3_ex_hdr exhdr;
			if (fs->Read(&exsz[0], 4)<4) Abort();
			int ex_size = (idhdr.maj_ver==4)? get_SynchsafeInt(&exsz[0]) : get_32bitInt(&exsz[0]);
			if (idhdr.maj_ver==4) ex_size-=4,
			fs->Seek(ex_size, soFromCurrent);
		}
		return true;
	}
	catch (...) {
		return false;
	}
}

//---------------------------------------------------------------------------
//MP3t@C ID3 Tag v2/v1 擾
//---------------------------------------------------------------------------
bool ID3_GetInf(
	UnicodeString fnam,		//t@C
	TStringList *lst,		//ʃXg(=e ̌`Ŋi[)
	bool id_min)			//ŏ̏ T??=̌`Ŏ擾
{
	bool ret = false;
	try {
		if (!file_exists(fnam)) Abort();
		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));

		unsigned int maj_ver = 0, last_p = 0;
		if (ID3_getVer_toFrame(fs.get(), &last_p, &maj_ver)) {
			//ID3v2
			lst->Add(get_PropTitle(_T("ID3o[W")).cat_sprintf(_T("2.%u"), maj_ver));

			//t[wb_
			for (;;) {
				id3_frm_hdr   frmhdr;
				id3_frm_hdr_2 frmhdr2;
				UnicodeString id_str;
				if (maj_ver==2) {
					if (fs->Read(&frmhdr2, 6)< 6) Abort();
					id_str = get_str_from_buf(frmhdr2.frame_id, 3);
				}
				else {
					if (fs->Read(&frmhdr, 10)<10) Abort();
					id_str = get_str_from_buf(frmhdr.frame_id, 4);
				}
				if (id_str.IsEmpty()) break;

				int size;
				switch (maj_ver) {
				case 2: size = get_24bitInt(&frmhdr2.size[0]);		break;
				case 3: size = get_32bitInt(&frmhdr.size[0]);		break;
				case 4:
					frmhdr.size;
					size = get_SynchsafeInt(&frmhdr.size[0]);
					break;
				}

				if (id_str[1]=='T')  {
					//eLXgGR[fBO
					BYTE code;
					if (fs->Read(&code, 1)<1) Abort();
					size--;
					//\ɕϊ
					UnicodeString lbuf = id_str;
					if (id_min) {
						if      (contained_wd_i(_T("TPE1|TP1"), id_str)) lbuf.USET_T("TP1=");
						else if (contained_wd_i(_T("TALB|TAL"), id_str)) lbuf.USET_T("TAL=");
						else if (contained_wd_i(_T("TIT2|TT2"), id_str)) lbuf.USET_T("TT2=");
						else if (contained_wd_i(_T("TRCK|TRK"), id_str)) lbuf.USET_T("TRK=");
						else if (contained_wd_i(_T("TYER|TYE"), id_str)) lbuf.USET_T("TYE=");
						else										     lbuf = EmptyStr;
					}
					else {
						if      (contained_wd_i(_T("TALB|TAL"), id_str)) lbuf.USET_T("Ao");
						else if (contained_wd_i(_T("TCOM|TCM"), id_str)) lbuf.USET_T("Ȏ");
						else if (contained_wd_i(_T("TCON|TCO"), id_str)) lbuf.USET_T("W");
						else if (contained_wd_i(_T("TCOP|TCR"), id_str)) lbuf.USET_T("쌠");
						else if (contained_wd_i(_T("TDAT|TDA"), id_str)) lbuf.USET_T("t");
						else if (contained_wd_i(_T("TENC|TEN"), id_str)) lbuf.USET_T("GR[h");
						else if (contained_wd_i(_T("TIT1|TT1"), id_str)) lbuf.USET_T("O[v");
						else if (contained_wd_i(_T("TIT2|TT2"), id_str)) lbuf.USET_T("^Cg");
						else if (contained_wd_i(_T("TIT3|TT3"), id_str)) lbuf.USET_T("Tu^Cg");
						else if (contained_wd_i(_T("TLEN|TLE"), id_str)) lbuf.USET_T("Ȃ̒");
						else if (contained_wd_i(_T("TORY|TOR|TDOR"), id_str))
														 	 	   		 lbuf.USET_T("ȃ[XN");
						else if (contained_wd_i(_T("TPE1|TP1"), id_str)) lbuf.USET_T("A[eBXg");
						else if (contained_wd_i(_T("TPE2|TP2"), id_str)) lbuf.USET_T("oh/t");
						else if (contained_wd_i(_T("TPE3|TP3"), id_str)) lbuf.USET_T("w");
						else if (contained_wd_i(_T("TPOS|TPA"), id_str)) lbuf.USET_T("fBXN");
						else if (contained_wd_i(_T("TPUB|TPB"), id_str)) lbuf.USET_T("oŎ");
						else if (contained_wd_i(_T("TRCK|TRK"), id_str)) lbuf.USET_T("gbN");
						else if (contained_wd_i(_T("TRDA|TRD|TDRC"), id_str))
															 			 lbuf.USET_T("^");
						else if (contained_wd_i(_T("TYER|TYE"), id_str)) lbuf.USET_T("[XN");
						else											 lbuf = id_str;
						lbuf = get_PropTitle(lbuf);
					}

					//
					std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
					if (ms->CopyFrom(fs.get(), size)<size) Abort();
					ms->Seek(0, soFromBeginning);
					std::unique_ptr<TStringList> ts(new TStringList());
					switch (code) {
					case 3:	 ts->LoadFromStream(ms.get(), TEncoding::UTF8); break;
					default: ts->LoadFromStream(ms.get());
					}
					if (ts->Count>0 && !lbuf.IsEmpty()) lst->Add(lbuf + ts->Strings[0]);
				}
				else {
					fs->Seek(size, soFromCurrent);
				}
				if (fs->Position>=last_p) break;
			}
			ret = true;
		}
		else {
			//ID3v1
			char fbuf[128];
			fs->Seek(-128, soFromEnd);
			int n = fs->Read(fbuf, 128);
			if (n==128) {
				std::unique_ptr<char[]> sbuf(new char[32]);
				char *sp = sbuf.get();
				UnicodeString tmp;
				char *s = &fbuf[0]; memcpy(sp, s, 3); sp[ 3] = '\0'; tmp = sp;
				if (USAME_TI(tmp, "TAG")) {
					add_PropLine(_T("ID3o[W"), "1", lst);
					s = &fbuf[ 3]; memcpy(sp, s, 30); sp[30] = '\0'; tmp = sp;
					lst->Add((id_min? UnicodeString("TT2=") : get_PropTitle(_T("gbN"))) + tmp);
					s = &fbuf[33]; memcpy(sp, s, 30); sp[30] = '\0'; tmp = sp;
					lst->Add((id_min? UnicodeString("TP1=") : get_PropTitle(_T("A[eBXg"))) + tmp);
					s = &fbuf[63]; memcpy(sp, s, 30); sp[30] = '\0'; tmp = sp;
					lst->Add((id_min? UnicodeString("TAL=") : get_PropTitle(_T("Ao"))) + tmp);
					s = &fbuf[93]; memcpy(sp, s,  4); sp[ 4] = '\0'; tmp = sp;
					lst->Add((id_min? UnicodeString("TYE=") : get_PropTitle(_T("[XN"))) + tmp);
					s = &fbuf[97]; memcpy(sp, s, 30); sp[30] = '\0'; tmp = sp;
					if (!id_min) add_PropLine(_T("Rg"), tmp, lst);
					ret = true;
				}
			}
		}
	}
	catch (...) {
		lst->Clear();
	}
	return ret;
}

//---------------------------------------------------------------------------
//MP3t@C疄ߍ݉摜rbg}bvŎ擾 or t@Cɏo
//---------------------------------------------------------------------------
bool ID3_GetImage(
	UnicodeString fnam,			//t@C
	Graphics::TBitmap *bmpimg,	//o̓rbg}bv (default = NULL)
	UnicodeString o_fnam)		//o̓t@C	 (default = EmptyStr)
{
	bool ok = false;
	try {
		if (!file_exists(fnam)) Abort();
		std::unique_ptr<TFileStream> fs(new TFileStream(fnam, fmOpenRead | fmShareDenyNone));

		//ID3v2^Owb_
		unsigned int maj_ver = 0, last_p = 0;
		if (!ID3_getVer_toFrame(fs.get(), &last_p, &maj_ver)) Abort();

		//t[wb_
		for (;;) {
			id3_frm_hdr   frmhdr;
			id3_frm_hdr_2 frmhdr2;
			UnicodeString id_str;
			if (maj_ver==2) {
				if (fs->Read(&frmhdr2, 6)< 6) Abort();
				id_str = get_str_from_buf(frmhdr2.frame_id, 3);
			}
			else {
				if (fs->Read(&frmhdr, 10)<10) Abort();
				id_str = get_str_from_buf(frmhdr.frame_id, 4);
			}
			if (id_str.IsEmpty()) break;

			int size;
			switch (maj_ver) {
			case 2: size = get_24bitInt(&frmhdr2.size[0]);		break;
			case 3: size = get_32bitInt(&frmhdr.size[0]);		break;
			case 4: size = get_SynchsafeInt(&frmhdr.size[0]);	break;
			}

			if (contained_wd_i(_T("APIC|PIC"), id_str)) {
				//eLXgGR[fBO
				BYTE code;
				if (fs->Read(&code, 1)<1) Abort();
				size--;
				bool is_16 = (code==1 || code==2);

				std::unique_ptr<char[]> tbuf(new char[32]);
				//摜`
				if (maj_ver==2) {
					if (fs->Read(tbuf.get(), 3)<3) Abort();
					tbuf[3] = '\0';
					size -= 3;
				}
				//MIMI^Cv
				else {
					char *pb = tbuf.get();
					for (int i=0; i<32; i++,pb++) {
						if (fs->Read(pb, 1)<1) Abort();
						size--;
						if (*pb=='\0') break;
					}
				}
				UnicodeString img_typ = tbuf.get();

				//摜^Cv
				BYTE pic_typ;
				if (fs->Read(&pic_typ, 1)<1) Abort();
				size--;
				//Description ͓ǂݔ΂
				int nul_cnt = 0;
				for (;;) {
					char d;
					if (fs->Read(&d, 1)<1) Abort();
					size--;
					if (d!='\0') continue;
					nul_cnt++;
					if (!is_16 && nul_cnt==1) break;
					if ( is_16 && nul_cnt==2) break;
				}
				//C[W
				std::unique_ptr<TMemoryStream> ms(new TMemoryStream());
				if (ms->CopyFrom(fs.get(), size)<size) Abort();
				ms->Seek(0, soFromBeginning);

				if (contained_wd_i(_T("image/jpeg|jpg"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatJpeg)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".jpg");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}

				else if (contained_wd_i(_T("image/png|png"), img_typ)) {
					if (bmpimg) {
						if (!WIC_get_from_memory(ms.get(), bmpimg, GUID_ContainerFormatPng)) Abort();
						ok = !bmpimg->Empty;
					}
					else if (!o_fnam.IsEmpty()) {
						o_fnam = ChangeFileExt(o_fnam, ".png");
						ms->SaveToFile(o_fnam);
						ok = true;
					}
				}
				break;
			}
			else {
				fs->Seek(size, soFromCurrent);
			}
			if (fs->Position>=last_p) break;
		}
	}
	catch (...) {
		ok = false;
	}

	return ok;
}
//---------------------------------------------------------------------------
